//+---------------------------------------------------------------------+
//|                                              MLS-HL4.mq4            |
//| The Method of Least Squares                                         |
//|      High and Low ver. 4                                            |
//|             Copyright  Trofimov 2008                               |
//+---------------------------------------------------------------------+
//|                                             |
//|                                         |
//| :           |
//|            .            |
//|                          |
//|                .               |
//|      , 2008     |
//+---------------------------------------------------------------------+


#property copyright "Copyright  Trofimov Evgeniy Vitalyevich, 2008"
#property link      "http://multitest.semico.ru/mnk.htm"

//----  
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 2
//#property indicator_color2 DarkSeaGreen
//#property indicator_width2 0

//----  
extern int MyPeriod=12;
extern bool ReDraw=true; //- ,        
                          //  ,      ,    () 
//----   
double MLS_Angel[];
//datetime LastTime;
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int init()
  {
//---- x  ,   
   IndicatorBuffers(1);
//----   (  )
   SetIndexDrawBegin(0,MyPeriod);
   //SetIndexDrawBegin(1,MyPeriod);
//---- x   
   SetIndexBuffer(0,MLS_Angel);
   //SetIndexBuffer(1,MLS_b);
//----      
   IndicatorShortName("MLS-HL4 ("+MyPeriod+") = ");
   SetIndexLabel(0,"a");
   //SetIndexLabel(1,"b");
   //SetIndexStyle(1,DRAW_NONE, EMPTY, EMPTY, CLR_NONE);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
int start() {
   int limit, RD;
   if(ReDraw) RD=1;
   //  
   int counted_bars=IndicatorCounted();
//----   
   if(counted_bars<0) return(-1);
//----          
   limit=Bars-counted_bars-1+RD;
//----  
   double k1, i1, j1, k2, i2, j2;
   double a, b, y, S, H, L;
   int x;
//----  
   for(int t=limit-RD; t>-RD; t--) {
      
      //if(LastTime==iTime(NULL,0,t)) return(0); //  
      //LastTime=iTime(NULL,0,t);
      //if(t<5) Print(t,"===== ",TimeToStr(LastTime)," =====");
      k1=0; i1=0; j1=0; k2=0; i2=0;
      for(x=t+MyPeriod-1; x>=t; x--)
        { //    k1=a*i1+b*j1  k2=a*i2+b*j2
         H=High[x]/Point;
         L=Low[x]/Point;
         k1=k1+H*x;    k2=k2+H;
         k1=k1+L*x;    k2=k2+L;
         i1=i1+2*x*x;  i2=i2+2*x;
         j1=j1+2*x;           
        }
      j2=MyPeriod*2;
      //  
      a=(k1*j2-j1*k2)/(i1*j2-j1*i2);
      //b=(k2-i2*a)/j2;
      //   High  Low,    ,
      //   ,   y=ax+b,
      // x -   ,  y -  .
      MLS_Angel[t]=-a;
      if(!ReDraw && t==1) MLS_Angel[0]=-a;
      //MLS_b[t]=b*Point;
   }
   return(0);
}
//+------------------------------------------------------------------+

